Subject: Missing driver-specific sysfs attributes of scsi_device [was: Re: [PATCH v4 00/46] Register SCSI sysfs attributes earlier]

From: Steffen Maier <[email-masked]>
Date: Sat, 23 Oct 2021 22:54:45 +0200

Hi Bart, hi Martin,

since Friday 2021-10-22 our CI reports errors with linux-next. It complains 
about missing zfcp-lun resources (although that's a follow-on error). Machines 
that have their root-fs on zfcp-attached SCSI disk(s) are stuck in boot. 
Looking at user visible effects, I see zfcp-specific sysfs attributes of 
scsi_device missing:

$ lszfcp -D
/usr/sbin/lszfcp: line 390: 
/sys/bus/ccw/drivers/zfcp/0.0.1780/host0/rport-0:0-0/target0:0:0/0:0:0:1089224725//hba_id: 
No such file or directory
/usr/sbin/lszfcp: line 391: 
/sys/bus/ccw/drivers/zfcp/0.0.1780/host0/rport-0:0-0/target0:0:0/0:0:0:1089224725//wwpn: 
No such file or directory
/usr/sbin/lszfcp: line 392: 
/sys/bus/ccw/drivers/zfcp/0.0.1780/host0/rport-0:0-0/target0:0:0/0:0:0:1089224725//fcp_lun: 
No such file or directory

That made me think of this patch series. It also happened so that Martin 
applied the series to 5.16/scsi-queue on 2021-10-21. Linux-next merged it on 
2021-10-22:

Merging scsi-mkp/for-next (83c3a7beaef7 scsi: lpfc: Update lpfc version to 
14.0.0.3)
$ git merge -m Merge branch 'for-next' of 
git://git.kernel.org/pub/scm/linux/kernel/git/mkp/scsi.git scsi-mkp/for-next
...
+ drivers/s390/scsi/zfcp_ext.h                    |   4 +-
+ drivers/s390/scsi/zfcp_fsf.c                    |   2 +-
+ drivers/s390/scsi/zfcp_scsi.c                   |   8 +-
+ drivers/s390/scsi/zfcp_sysfs.c                  |  52 ++--
[https://git.kernel.org/pub/scm/linux/kernel/git/next/linux-next.git/commit/?h=next-20211022&id=cf6c9d12750cf6f3f6aeffcd0bdb36b1ac993f44]

So this seems to match with the occurrence of problems for us.

I wonder if any of the other LLDDs see similar problems. I left those LLDD 
patches in the list below, that also were migrated from sdev_attrs to sdev_groups.

Guess it would be good to fix this before the v5.16 merge window opens 
(2021-11-08 after predicted v5.15 release? [http://phb-crystal-ball.org/]) so 
the error does not land in Linus' tree (which our CI also tests).

Not sure if I'll find time to dig deeper.

On 10/21/21 05:42, Martin K. Petersen wrote:
> On Tue, 12 Oct 2021 16:35:12 -0700, Bart Van Assche wrote:
> 
>> For certain user space software, e.g. udev, it is important that sysfs
>> attributes are registered before the KOBJ_ADD uevent is emitted. Hence
>> this patch series that removes the device_create_file() and
>> sysfs_create_groups() calls from the SCSI core. Please consider this
>> patch series for kernel v5.16.
>>
>> Thanks,
>>
>> [...]
> 
> Applied to 5.16/scsi-queue, thanks!
> 
> [01/46] scsi: core: Register sysfs attributes earlier
>          https://git.kernel.org/mkp/scsi/c/92c4b58b15c5
> [02/46] ata: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/c3f69c7f629f
> [03/46] firewire: sbp2: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/5e88e67b6f3b

> [06/46] scsi: zfcp: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/d8d7cf3f7d07

> [10/46] scsi: 53c700: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/90cb6538b5da
> [11/46] scsi: aacraid: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/bd16d71185c8

> [18/46] scsi: cxlflash: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/780c678912fb

> [21/46] scsi: hpsa: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/4cd16323b523

> [25/46] scsi: ipr: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/47d1e6ae0e1e

> [28/46] scsi: megaraid: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/09723bb252ca
> [29/46] scsi: mpt3sas: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/1bb3ca27d2ca

> [31/46] scsi: myrb: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/582c0360db90
> [32/46] scsi: myrs: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/087c3ace6337

> [42/46] scsi: smartpqi: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/64fc9015fbeb

> [45/46] scsi: usb: Switch to attribute groups
>          https://git.kernel.org/mkp/scsi/c/01e570febaaa
> [46/46] scsi: core: Remove two host template members that are no longer used
>          https://git.kernel.org/mkp/scsi/c/a47c6b713e89

-- 
Mit freundlichen Gruessen / Kind regards
Steffen Maier

Linux on IBM Z and LinuxONE

https://www.ibm.com/privacy/us/en/
IBM Deutschland Research & Development GmbH
Vorsitzender des Aufsichtsrats: Gregor Pillen
Geschaeftsfuehrung: Dirk Wittkopp
Sitz der Gesellschaft: Boeblingen
Registergericht: Amtsgericht Stuttgart, HRB 243294